/*** FrostProtection.cc ***/
//------------------------------------------------

 #include "WatchDog.cc"
 #include "I2C.cc"
 #include "DS2482.cc"
 #include "DS18S20.cc"

 #define I2C_SCL PC0
 #define I2C_SDA PC1
 #define RELAY_1 PC4
 #define RELAY_2 PC5
 #define LED_RUN PD4
 #define LED_COK PD5

 #define LED_ERR PB3

//------------------------------------------------

 void main(void)
    {
    char  ac_msg[15];
    float f_temperature;
    byte  by_count;

    WatchDogInit(WDT_1536_MS);
    WatchDogStart();

    Port_DataDirBit(LED_RUN, 1);
    Port_DataDirBit(LED_COK, 1);
    Port_DataDirBit(LED_ERR, 1);
    Port_DataDirBit(RELAY_1, 1);
    Port_DataDirBit(RELAY_2, 1);

    Port_WriteBit(LED_RUN, 0);
    Port_WriteBit(LED_COK, 0);
    Port_WriteBit(LED_ERR, 0);
    Port_WriteBit(RELAY_1, 0);
    Port_WriteBit(RELAY_2, 0);

    Port_DataDirBit(I2C_SCL, 0);
    Port_DataDirBit(I2C_SDA, 0);
    Port_WriteBit(I2C_SCL, 1);
    Port_WriteBit(I2C_SDA, 1);
    I2C_Init(I2C_100kHz);

   if(ConvInit(CONV_WRITE_ADDR_1))
        //Msg_WriteText("Converter -> OK\r");
        Port_ToggleBit(LED_COK);
    else
        //Msg_WriteText("Converter -> ERROR\r");
        Port_WriteBit(LED_ERR, 1);

    by_count = 1;
    WatchDogReset();
    while(1)
        {
        f_temperature = ConvRead(CONV_WRITE_ADDR_1);
        if(INVALID_VALUE != f_temperature)
            {
/*
            Str_Printf(ac_msg, "%5.2f", f_temperature);
            Msg_WriteWord(by_count);
            Msg_WriteText(" : Futtertemperatur: ");
            Msg_WriteText(ac_msg);
            Msg_WriteChar(13);
*/
            Port_ToggleBit(LED_COK);
            }
        else
            {
            //Msg_WriteText("Futtertemperatur: Fehler\r");
            Port_WriteBit(LED_ERR, 1);
            ConvInit(CONV_WRITE_ADDR_1);
            }

// ber 10C Heizung aus
        if(10.0 < f_temperature)
            {
            Port_WriteBit(RELAY_1, 0);
            Port_WriteBit(RELAY_2, 0);
            }

// unter 5C Heizung an (Frostschutz)
        if(5.0 > f_temperature)
            {
            Port_WriteBit(RELAY_1, 1);
            Port_WriteBit(RELAY_2, 1);
            }

// unter 25C Futter trocken halten
        if((25 > f_temperature) && (!by_count++))
            {
            Port_WriteBit(RELAY_1, 1);
            Port_WriteBit(RELAY_2, 1);
            WatchDogStop();
            Thread_Delay(1000);
            WatchDogStart();
            }

        Port_ToggleBit(LED_RUN);
        WatchDogReset();
        }

    }

//------------------------------------------------